var address_840 = {
        street: {
            selector: '#'+'Street#Index',
            value: '#IF(#AddressAttributes.CountryID EQ "840")#AddressAttributes.Street#ENDIF'
        },
        zip: {
            selector: '#'+'Zipcode#Index',
            value: '#IF(#AddressAttributes.CountryID EQ "840")#AddressAttributes.Zipcode#ENDIF'
        },
        city: {
            selector: '#'+'City#Index',
            value: '#IF(#AddressAttributes.CountryID EQ "840")#AddressAttributes.City#ENDIF'
        },
        state: {
            selector: '#'+'State#Index',
            value: '#IF(#AddressAttributes.CountryID EQ "840")#AddressAttributes.State#ENDIF'
        }
    };

#IF( (NOT #DEFINED(#Shop.Address.CountryID)) OR (#Shop.Address.CountryID != "840") OR ( (#Shop.Address.CountryID == "840") AND (#Shop.CanUseTaxUS == "1" ) ) )
#LOCAL("CountryNotChangeable", NOT(#InitialShopWizardStartup) AND #DEFINED(#Shop.Address.CountryID) AND #Shop.Address.CountryID EQ "840")
countries['840'] = {
    template: '#ShopWizardSteps-Contact-Tmpl-US',
    address: address_840,
    onBeforeRender: function () {
        #IF(NOT(#CountryNotChangeable))
        $('#ShopWizardSteps-Contact-Tmpl-US-CountryNotChangeable-Warning').hide();
        #ENDIF
    },
    onAfterRender: function (address) {
        var show = (address && address.zip !== undefined && address.zip.value !== undefined && address.zip.value.length) ? true : false;

        require(['de_epages/taxus/inc/taxus-tools'], function (taxusTools) {
            var wrapper = $('div.cityAndState');
            // add functionality to insert a zip code and get the corresponding
            // county/country/state data for the select field via AJAX
            taxusTools.wizardAddAddress(
                $.extend(address_840, {
                    taxMatrixId: #Shop.Child.TaxMatrixUS.ID,
                    cityAndState: wrapper,
                    spanCity: wrapper.find('span.city'),
                    spanState: wrapper.find('span.state'),
                    show: show,

                    // callback - executed when an input occurs
                    onBeforeSelect: function($zip) {
                        var validateWidget = $zip.data('uiUiValidate');

                        // if zip input is an uiValidate widget and is already initialized
                        if (validateWidget && $zip.data('initialized')) {
                            // set state of zip input invalid
                            validateWidget._setValidStatus(false);
                        }

                        // manually mark zip input as initialized
                        $zip.data('initialized', true);
                    },
                    // callback - executed after an entry was selected from the autocomplete list
                    onAfterSelect: function($zip) {
                        var validateWidget = $zip.data('uiUiValidate');

                        if (validateWidget) {
                            // set state of zip input valid
                            validateWidget._setValidStatus(true);
                        }
                    },
                    // additional event handler - executed when the form.submit event triggers
                    onSubmit: function(event, data) {
                        var $zip = data.zip,
                            autocompleteWidget = $zip.data('uiAutocomplete');

                        // if autocomplete widget exists and is invalid
                        if (autocompleteWidget && $zip.hasClass('ui-invalid')) {
                            // remove hidden inputs and display suggest list
                            data.setHiddenInputs();

                            // display autocomplete list if a search term exists
                            if (autocompleteWidget.term !== undefined) {
                                autocompleteWidget.menu.activeMenu.show();
                            } else {
                                if (!autocompleteWidget.NOT_VALID) {
                                    $zip.autocomplete('search', $zip.val());
                                }
                            }

                            // hide suggest list if invalid input
                            if (autocompleteWidget && autocompleteWidget.NOT_VALID) {
                              autocompleteWidget.menu.activeMenu.hide();
                            }
                        }
                    },
                    // additional event handler - executed when the form.submit event triggers
                    onFocus: function(event, data) {
                        var $zip = data.zip,
                            autocompleteWidget = $zip.data('uiAutocomplete');

                        // if autocomplete widget exists and is invalid
                        if (autocompleteWidget && $zip.hasClass('ui-invalid')) {

                            // display autocomplete list if a search term exists
                            if (autocompleteWidget.term !== undefined) {
                                autocompleteWidget.menu.activeMenu.show();
                            }

                            // hide suggest list if invalid input
                            if (autocompleteWidget && autocompleteWidget.NOT_VALID) {
                              autocompleteWidget.menu.activeMenu.hide();
                            }
                        }
                    }
                })
            );

            // set TaxModel input to 0
            $('input[type="hidden"][name="TaxModel"]').val(0);
            $('#'+'CanUseTaxUS').val(1);
        });
        #IF(NOT(#CountryNotChangeable) AND NOT(#InitialShopWizardStartup))
        $('#ShopWizardSteps-Contact-Tmpl-US-CountryNotChangeable-Warning').show();
        #ENDIF
    }
};

var countrySelect = $('#' + 'CountryID#Index');

#IF(#CountryNotChangeable)
countrySelect
    .prop('disabled', true)
    .hide(0);
countrySelect.before($('<span style="width: 160px; float: left; margin-bottom: 10px;" class="ep-input-style-disabled">' + countrySelect[0].options[countrySelect[0].selectedIndex].text + '</span>'));
#ELSE
countrySelect.before($('#ShopWizardSteps-Contact-Tmpl-US-CountryNotChangeable').tmpl());
$('#ShopWizardSteps-Contact-Tmpl-US-CountryNotChangeable-Tooltip').metaparse();
#ENDIF
#ENDLOCAL
#ENDIF
